## Version 0.0.1 - July 15 2011
initial project hierarchy setup, named kitkat for kontinuous integrated testing koffee application template (yes the correct spelling is c's instead of k's...but have a break, have a kitkat)

Initial goals of this project is to create a build tool that will initialize automated testing components for a coffee-script based application, it was originally going to be a piece built into  another project but soon grew into a separate project on it's own.

The list of features I would like to include (though not limited) are as follows: 

* Automate monitoring and build of coffee-script files
* Automate execution of compiled specs 
* Notify when test specs pass/fail with instant feedback 
* Provide a code coverage report
* hook into git commit to require successful pass of code prior to commits
* pass/fail history to database support if required (Will not be mandatory)
* Benchmarking - considering how and if this should be a piece within kitkat itself

## Version 0.0.2 - July 15 2011
Third party libraries added including:

* optimist - provides a very light weight command line argument processor
* async - some advanced flow control for node.js applications
* envjasmine - headless jasmine based testing environment
* growl - notification system (requires growlnotify extra in order to work)
* stalker - recursive directory monitoring for file changes
* uglify-js - produce a single minified app.js file

Additional changes include:

* Configuration of the lib/env_jasmine/include/dependancies.js file setting the default src and test directory.
* Creation of the package.json file
* Addition of the MIT license
* Update version from 0.0.1 to 0.0.2

## Version 0.0.3 - July 20 2011

Changes include:

* Dynamic, recursive file gathering to determine the files needed for tests
* Async functionality to ensure file gathering completes before testing
* Introduction of optional configuration file stored in your project/dependancy folder called kitkat_config.js
* implementation of the command parser and usage functionality
* growl notifications enabled

Bugs removed:

* too many to iterate at this time, code still in beta

## Version 0.0.4 - July 25 2011

Changes include:

* Autospec and spec functionality completed
* Stalker library included to monitor directories containing code and spec files
* Paths corrected for placement of the libraries and determing location to support gloabl install to /usr/local path
* NPM package published and tested
* Modification of the EnvJasmine package to support a project path command argument, this is required to allow access to files outside of EnvJasmine's location which is in the lib folder beneath this project and could be inside /usr/local instead of your project.

Bug Removed:

* Missing callback in the create specs task of the test function.
* Path to dependancy file in project instead of library location.
* Far too many again, this is still beta.

Known Issues:

* Stalker library calls back on modified files it has logged when new files are added, net result is I've had to remove watches before they are added, while this is not clean, it is functional, further review of the stalker library and possible bug report to follow.
* Code currently does not exclude certain directories, this is not a bug as much as it allows for possibly bad behavior based on the configured source and spec directories, i.e. if you had code files under node_modules and specified the root of your folder as the project folder then it could try to compile and include those in your final application.
* Spec files are created based on the code file name, the only limitation is the spec folder is kept as a flat folder with all specs in the same hierarchy, if a project uses multiple code files with the same name but different subfolders then you would have a conflict in the spec file name.
* Many more i'm sure, please report bugs as they are found and code enhancements as they become obvious.

## Version 0.0.5 - July 26 2011

Changes include:

* Modified the combine method to use .app.js for the combined compiled coffee-script file.
* Corrected a typo: dependency instead of dependancy (sigh)
* Removed node_modules from walk function by way of a conditional check

Bugs Removed:

* Code did not exclude certain directories, such as node_modules which could contain other .coffee files and should not be included.  It may be that in the future we will include a .kitkatignore file to list exclusions in addition to this.

Known Issues: 

* Stalker library calls back on modified files it has logged when new files are added, net result is I've had to remove watches before they are added, while this is not clean, it is functional, further review of the stalker library and possible bug report to follow.
* Spec files are created based on the code file name, the only limitation is the spec folder is kept as a flat folder with all specs in the same hierarchy, if a project uses multiple code files with the same name but different subfolders then you would have a conflict in the spec file name.
* Many more i'm sure, please report bugs as they are found and code enhancements as they become obvious.

## Version 0.0.6 - July 26 2011

Changes include:

* Modified configuration file and code to use new variable prodTargetCreate defaulted to false, this variable will control whether we create the combined coffee script file, and resulting .app.js and .min.js which is mostly useful for client applications.  Our default is server applications so we will typically just want the code files compiled from .coffee to .js individually.
* Modified the default deployment folder to lib/ of the current project, again still modifiable in the configuration file if needed.
* Added an Example section o the README.md file illustrating the procedure to use kitkat with a new application

Bugs Removed:

* Bad path to the lib folder for growl-notify icons, corrected to use path variable pointed at lib folder
* Removed extra call to util.log which was outputting created js files on screen

Known Issues:

* Stalker library calls back on modified files it has logged when new files are added, net result is I've had to remove watches before they are added, while this is not clean, it is functional, further review of the stalker library and possible bug report to follow.
* Spec files are created based on the code file name, the only limitation is the spec folder is kept as a flat folder with all specs in the same hierarchy, if a project uses multiple code files with the same name but different subfolders then you would have a conflict in the spec file name.
* Many more i'm sure, please report bugs as they are found and code enhancements as they become obvious.

## Version 0.0.7 - August 3 2011

Changes include:

* Created commonjs.js file to mock up basic require functionality so that tests will not fail simply for the missing require keyword in Rhino. 
* Specified the path used in spec files to use EnvJasmine.projectPath rather than the fully coded path when spec file is originally created (allows project to move without breaking the spec files.)

Bugs removed: 

* growl-notify no longer displays an error message when tests succeed, this was a result of rhino throwing an error on keywords it did not understand or have implemented for javascript testing. (yet)

Known Issues:

* Stalker library calls back on modified files it has logged when new files are added, net result is I've had to remove watches before they are added, while this is not clean, it is functional, further review of the stalker library and possible bug report to follow.
* Spec files are created based on the code file name, the only limitation is the spec folder is kept as a flat folder with all specs in the same hierarchy, if a project uses multiple code files with the same name but different subfolders then you would have a conflict in the spec file name.
* Many more i'm sure, please report bugs as they are found and code enhancements as they become obvious.

## Version 0.1.0 - August 8 2011

changes include:

* Modified command line argument processing, now accepts new parameters for the following:
	* uglify - will cause the code being tested to be compiled into a single js file and then minified using the uglify-js library, this is ideal for client side applications
	* engine - ability to now specify one of three engines to be used by kitkat, these include expresso (default), jasmine-node and the envJasmine + rhino for testing.

Known Issues:

* Stalker library calls back on modified files it has logged when new files are added, net result is I've had to remove watches before they are added, while this is not clean, it is functional, further review of the stalker library and possible bug report to follow.
* Spec files are created based on the code file name, the only limitation is the spec folder is kept as a flat folder with all specs in the same hierarchy, if a project uses multiple code files with the same name but different subfolders then you would have a conflict in the spec file name.
* Many more i'm sure, please report bugs as they are found and code enhancements as they become obvious.
 
